@echo off
pushd "%~dp0"
call _setenv.bat

call "%BAT_TOOLS_ROOT%\msbuildvars.bat" vs2010

cd /d %TEMPDIR%
if not exist zlib-1.2.5 (
	goto error
)

if not exist libpng-%VERSION% goto end
cd libpng-%VERSION%
if not exist projects goto end
cd projects

set VCDIR=vstudio

cd %TEMPDIR%\libpng-%VERSION%\projects
cd %VCDIR%

goto build

if exist zlib.props (
	if not exist zlib.props.bak (
		@echo F | xcopy /Y /Q zlib.props zlib.props.bak
	)
	sed -e "s/zlib-1.2.5/zlib/g" zlib.props.bak
	pause
)

:build

rem LIB
msbuild /p:Configuration="Debug Library"		/p:Platform=Win32	/t:Build "vstudio.sln"
if errorlevel 1 goto error
msbuild /p:Configuration="Release Library"		/p:Platform=Win32	/t:Build "vstudio.sln"
if errorlevel 1 goto error

rem DLL
msbuild /p:Configuration="Debug"		/p:Platform=Win32	/t:Build "vstudio.sln"
if errorlevel 1 goto error
msbuild /p:Configuration="Release"		/p:Platform=Win32	/t:Build "vstudio.sln"
if errorlevel 1 goto error

cd /d "%~dp0"
call filesync.bat %TEMPDIR%\libpng-%VERSION%\projects\%VCDIR% msvc10 2010

goto end

:error
pause

:end
cd /d %TEMPDIR%

cd /d "%~dp0"

