@echo off
call _setenv.bat
pushd %~dp0

cd /d %CVINSTALLDIR%
if errorlevel 1 goto error

call "%BAT_TOOLS_ROOT%\msbuildvars.bat" vs2010

SET OPTION=-D BUILD_DOXYGEN_DOCS=OFF -D BUILD_PYTHON_SUPPORT=ON -D ENABLE_OPENMP=OFF -D BUILD_SHARED_LIBS=OFF
SET RUNTIMELIB=md
SET VCNUM=2010
SET VCDIR=msvc10
SET WORKSPACE=build\static\%VCDIR%
SET GENRATOR="Visual Studio 10"

rem CMake
if not exist %WORKSPACE%\OpenCV.sln (
	if not exist build			mkdir build
	if not exist build\static	mkdir build\static

	if not exist %WORKSPACE%	mkdir %WORKSPACE%
	cd %WORKSPACE%
	cmake -G %GENRATOR% %OPTION%  ../../../
) else (
	cd %WORKSPACE%
)

rem Debug
msbuild /p:Configuration=Debug /p:Platform=Win32		/t:Build OpenCV.sln
if errorlevel 1 goto error

rem Release
msbuild /p:Configuration=Release /p:Platform=Win32		/t:Build OpenCV.sln
if errorlevel 1 goto error

:filesync
cd /d "%~dp0"
call filesync_static.bat

goto end

:error
pause

:end
popd


