//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		test.cpp
 * @brief		test t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define _FILE_test_CPP_

//======================================================================
// include
#include "unit/gt/gt_inchead.h"
#include "iris_iostream.h"
#include "iris_using.h"
#include "hollow/scoped_thread/scoped_thread.h"

TEST(Test, judgment)
{
	union TEST
	{
		u8 v;
		struct
		{
			u8 b0:1;
			u8 b1:1;
			u8 b2:1;
			u8 b3:1;
			u8 b4:1;
			u8 b5:1;
			u8 b6:1;
			u8 b7:1;
		};
	};

	TEST t;
	t.v = 0x01;

	if( t.b0 )
	{
		printf("bitfield low assign.\n");
	}
	else
	{
		printf("bitfield high assign.\n");
	}
}

TEST(Test, bitfield)
{
	strcpy(NULL, NULL);
}


TEST(Test, Shift)
{
	for( BYTE i=0; i < 0x10; ++i )
	{
		printf("%x -> %x\n", i, (i ^ 0x2u) - 0xA);
	}
}

class Shokupan 
{
	int m_num;
public:
	Shokupan(int n) : m_num(n) {}
public:
	int num(void) { return m_num; }
};

TEST(Shokupan, Change)
{
	Shokupan face(6);
	ASSERT_TRUE(face.num() == 6);
	ASSERT_EQ(5, face.num());
}
