//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		cpp0x_iterator_traits.hpp
 * @brief		iterator t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_cpp0x_iterator_traits_HPP_
#define INCG_IRIS_cpp0x_iterator_traits_HPP_

//======================================================================
// include
#include "cpp0x_type_traits_def.hpp"

namespace cpp0x
{

//======================================================================
// declare
template<typename TN_>class iterator_trait;		// iterator_trait

//======================================================================
// class
/// is iterator
template<typename TN_>
class iterator_trait
{
	template<typename TT>
	struct impl
	{
		typedef typename TT::value_type	type;
	};
	template<typename TT>
	struct impl<TT*>
	{
		typedef TT	type;
	};
	template<typename TT>
	struct impl<const TT*>
	{
		typedef TT	type;
	};
public:
	typedef typename impl<TN_>::type	type;
};

}	// end of namespace cpp0x

//======================================================================
// include
#include "cpp0x_type_traits_undef.hpp"

#endif
