//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		FndDES.h
 * @brief		DESÍNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_FndDES_H_
#define INCG_IRIS_FndDES_H_

//======================================================================
// include
#include "FndCipherBase.h"
#include "../../iris_debug.h"

namespace iris {
namespace fnd
{

//======================================================================
// class
/**
 * @brief	DESÍNX
 * @deprecated	
*/
class CDES : public IBlockCipher
{
public:
	typedef enum
	{
		KBITS		= 56,			//!< rbg
		NK			= KBITS/32,		//!< 
		KEYSIZE		= KBITS/8,		//!< oCg

		BBITS		= 64,			//!< ubNrbg
		NB			= BBITS/32,		//!< ubN[h
		BLOCKSIZE	= BBITS/8,		//!< ubNoCg

		NR			= 16,	//!< Eh ((NK > NB ? NK : NB) + 6)
		KSBITS		= 48,	//!< L[XPW[bit
		KS_LENGTH	= KSBITS/8	//!< L[XPW[oCg
	} TYPES;

private:
	u8		m_KeySch[NR][KS_LENGTH];	//!< L[XPW[

public:
	// RXgN^
	CDES(void);
	// fXgN^
	virtual ~CDES(void)	{}

public:
	/// ubNoCg̎擾
	virtual u32		GetBlockSize(void)	const	{ return BLOCKSIZE; }
	/// oCg̎擾
	virtual u32		GetKeySize(void)	const	{ return KEYSIZE; }
public:
	// ̍쐬
	virtual bool	CreateKeys(const u8* pkey, u32 nSize);
public:
	// Í
	virtual bool	EncryptBlock(u8* dst, const u8* src);
	// 
	virtual bool	DecryptBlock(u8* dst, const u8* src);
};

}	// end of namespace fnd
}	// end of namespace iris

#endif
