//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		MathFpuTest.cpp
 * @brief		t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define INCG_IRIS_MathFpuTest_CPP_

//======================================================================
// include
#include "MathVector2.h"
#include "MathVector3.h"
#include "MathVector4.h"
#include "MathMatrix22.h"
#include "MathMatrix33.h"
#include "MathMatrix44.h"
#include "MathPerspective.h"
#include "MathPlane.h"
#include "MathQuaternion.h"
#include "MathFpuInline.h"
#include "MathScalar.h"
#include "MathColor.h"
#include "MathComplex.h"

#if (defined(_IRIS_UNITTEST) || defined(_IRIS_MULTI_UNITTEST))

//======================================================================
// include
#include "../../unit/UnitCore.h"
#include "../../iris_using.h"

//======================================================================
// test
IRIS_UNITTEST(CMathFpuUnitTest, Func)
{
	// log2
	IRIS_ASSERT( (s32)FpuScalarLog2(128.0f) == 7 );
	IRIS_ASSERT( (s32)FpuScalarLog2(127.0f) == 6 );
}

#endif
