//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		HvkSystem.h
 * @brief		Havok VXe t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_HvkSystem_H_
#define INCG_IRIS_HvkSystem_H_

//======================================================================
// include
#include "HvkMemory.h"

#ifdef _IRIS_SUPPORT_HAVOK

namespace iris {
namespace havok
{

//======================================================================
// class
/**
 * @ingroup	Havok
 * @brief	HavokNX
*/
class CHavokSystem : public IIrisObject
{
private:
	CMemoryRouter	m_Router;	//!< [^[
public:
	// RXgN^
	CHavokSystem(void);
	// fXgN^
	~CHavokSystem(void);

public:
	// 
	bool	Initialize(void);
	bool	Initialize(hkMemoryAllocator* memoryAllocator, const hkMemorySystem::FrameInfo& info);
	// I
	void	Terminate(void);
};

}	// end of namespace havok
}	// end of namespace iris

#endif

#endif
