//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		HvkCylinderShape.cpp
 * @brief		Havok CylinderShape t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define INCG_IRIS_HvkCylinderShape_CPP_

//======================================================================
// include
#include "HvkCylinderShape.h"


#ifdef _IRIS_SUPPORT_HAVOK

namespace iris {
namespace havok
{

//======================================================================
// class
/**********************************************************************//**
 *
 * RXgN^
 *
*//***********************************************************************/
CCylinderShape::CCylinderShape(void)
{
}

/**********************************************************************//**
 *
 * fXgN^
 *
*//***********************************************************************/
CCylinderShape::~CCylinderShape(void)
{
}

/**********************************************************************//**
 *
 * 쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	vertexA			= ~[_
 * @param [in]	vertexB			= ~[_
 * @param [in]	radius			= a
 * @param [in]	paddingRadius	= 덷
 * @retrun	
*//***********************************************************************/
bool CCylinderShape::Create(const hkVector4& vertexA, const hkVector4& vertexB, hkReal radius, hkReal paddingRadius)
{
	Delete();
	m_ptr = new hkpCylinderShape(vertexA, vertexB, radius, paddingRadius);
	if( m_ptr == nullptr ) return false;
	return true;
}

}	// end of namespace havok
}	// end of namespace iris

#endif
