//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		AsException.h
 * @brief		angelscript O t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 *
 * @par			copyright
 * Copyright (C) 2012 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_AsException_H_
#define INCG_IRIS_AsException_H_

//======================================================================
// include
#include "as_inchead.h"

#ifdef _IRIS_SUPPORT_ANGELSCRIPT

#if _IRIS_ANGELSCRIPT_HAS_EXCEPTION
#include <exception>
#include <string>

namespace iris {
namespace as
{


/**
 * @brief	angelscript O
*/
class as_exception : public std::exception
{
public:
	int line, column;
	const char* function;
public:
	as_exception(const char *const& _What, const char* _func, int _line, int _column)
		: std::exception(_What), function(_func), line(_line), column(_column)  {}
	as_exception(void) : std::exception() {}
	~as_exception(void) {}
};


}	// end of namespace as
}	// end of namespace iris

#endif

#endif

#endif